﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace loves
{
    class Loves
    {
        public string Sorozat { get; set; }
        public int ID { get; set; }
        public Loves(int id, string adat)
        {
            ID = id;
            Sorozat = adat;
        }
        public int Loertek()
        {
            int aktpont = 20;
            int ertek = 0;
            for (int i = 0; i < Sorozat.Length; i++)
            {
                if (aktpont > 0 && Sorozat[i] == '-')
                {
                    aktpont = aktpont - 1;
                }
                else
                {
                    ertek = ertek + aktpont;
                }
            }
            return ertek;
        }


    }

    class Program
    {
        static Loves[] kupac;

        static void Main(string[] args)
        {
            int N; //versenyzők száma
            List<Loves> verseny = new List<Loves>();

            //1. feladat
            using (System.IO.StreamReader sr = new System.IO.StreamReader("verseny.txt"))
            {
                N = int.Parse(sr.ReadLine());
                for (int i = 0; i < N; i++)
                {
                    verseny.Add(new Loves(i + 1, sr.ReadLine()));
                }
            }

            //2. feladat: 2 vagy több egymásutáni jó lövés
            Console.Write("2. feladat:\nAz egymast kovetoen tobbszor talalo versenyzok: ");
            foreach (Loves l in verseny)
            {
                if (l.Sorozat.Contains("++"))
                {
                    Console.Write(l.ID + " ");
                }
            }
            Console.WriteLine();

            //3. feladat legtöbb lovést leadó
            Console.WriteLine("3. feladat:");
            int maxh = 0;
            for (int i = 1; i < N; i++)
            {
                if (verseny[i].Sorozat.Length > verseny[maxh].Sorozat.Length)
                {
                    maxh = i;
                }
            }
            Console.WriteLine("A legtobb lovest leado versenyzo rajtszama: {0}", verseny[maxh].ID);

            //5. feladat
            Console.WriteLine("5. feladat: ");
            Console.Write("Adjon meg egy rajtszamot! ");
            int id = int.Parse(Console.ReadLine());
            int db = 0;         //b feladathoz
            int maxhossz = 0;      //c feladathoz
            int akthossz = 0;   //c feladathoz

            //5a (egyben az 5b és 5c megoldása is)
            Console.Write("5a feladat: Celt ero lovesek: ");
            for (int i = 0; i < verseny[id - 1].Sorozat.Length; i++)
            {
                if (verseny[id - 1].Sorozat[i] == '+')
                {
                    Console.Write("{0} ", i + 1);
                    db++;
                    akthossz++;
                }
                else
                {
                    if (akthossz > maxhossz)
                    {
                        maxhossz = akthossz;
                    }
                    akthossz = 0;
                }
            }

            Console.WriteLine();
            //5b
            Console.Write("5b feladat: Az eltalalt korongok szama: {0}", db);
            Console.WriteLine();
            //5c
            Console.Write("5c feladat: A leghosszabb hibatlan sorozat hossza: {0}", maxhossz);
            Console.WriteLine();
            //5d (mindkét függvénnyel)
            Console.Write("5d feladat: A versenyzo pontszama: {0}", verseny[id - 1].Loertek());
            Console.WriteLine();
            Console.Write("5d feladat: A versenyzo pontszama: {0}", Loertek(verseny[id - 1].Sorozat));
            Console.WriteLine();

            //6. feladat
            kupac = new Loves[N + 2];
            verseny.CopyTo(kupac, 1);

            //gyorsmegoldás
            verseny.Sort(delegate(Loves p, Loves q) { return q.Loertek().CompareTo(p.Loertek()); });

            using (System.IO.StreamWriter sw = new System.IO.StreamWriter("sorrend.txt"))
            {
                sw.WriteLine("{0}\t{1}\t{2}", 1, verseny[0].ID, verseny[0].Loertek());
                int akt = 1;
                for (int i = 1; i < N; i++)
                {
                    akt = verseny[i - 1].Loertek() == verseny[i].Loertek() ? akt : (i + 1);
                    sw.WriteLine("{0}\t{1}\t{2}", akt, verseny[i].ID, verseny[i].Loertek());
                }
            }

            //kupac-rendezve...
            #region kupacolás
            int A = N / 2;      //aktuálisan vizsgált részfa gyökere
            if (N % 2 == 0)     //nincs a végén balgyerek
            {
                //az utolsó után beteszek egy nagyon kicsielemet, ha vele azonos értékű, akkor se ez legyen az eredmény...
                kupac[N + 1] = new Loves(N + 1, "------------------------------");

            }
            while (A > 0)       //alulról felfelé az A-gyökérig kupacolt
            {
                Sullyeszt(N, A);
                A--;
            }
            #endregion
           
            using (System.IO.StreamWriter sw = new System.IO.StreamWriter("kupacrend.txt"))
            {
                int H = N;      //a vizsgált tömb hossza
                int pont = kupac[1].Loertek();
                int hely = 1;
                
                while (H>1)
                {
                    sw.WriteLine("{0}\t{1}\t{2}", hely, kupac[1].ID, pont); //aktuális max kimásolása
                    kupac[1] = kupac[H];                                    //végéről az elejére, kupac elrontása
                    H--;                                                    //"törlés a végéről", rövidebb szakasz

                    Sullyeszt(H, 1);                                        //csúcs süllyesztése a kupac helyreállítása

                    if (pont != kupac[1].Loertek())                         //változik a pont, új helyezési szám kell
                    {
                        pont = kupac[1].Loertek();
                        hely = N + 1 - H;                                   //Teljes elemszámból és a még hátralevő elemek száma alapján
                    }
                }
                sw.WriteLine("{0}\t{1}\t{2}", hely, kupac[1].ID, pont);     //utolsó kiírása (lehetne az elsővel is...

            }

            Console.ReadLine();
        }

        private static void Sullyeszt(int H, int S)
        { //A kupac H hosszú darabjában az S. helyről süllyeszt.
            //Páros elemszám esetén a H + 1. helyen (balgyerek) a vizsgált elemnek (előzetes másolás miatt) vagy egy nagyon kicsi elemnek kell lennie.
            bool jó = false;
            while (2 * S <= H && !jó)
            {
                int nagyobb = kupac[2 * S].Loertek() >= kupac[2 * S + 1].Loertek() ? (2 * S) : (2 * S + 1);
                //az = azért kell, hogy az esetleges balgyerek egyenéő vagy plusz elemet ne válassza ki
                
                if (kupac[nagyobb].Loertek() > kupac[S].Loertek())
                {
                    Loves tmp = kupac[nagyobb];
                    kupac[nagyobb] = kupac[S];
                    kupac[S] = tmp;
                    S = nagyobb;
                }
                else
                {
                    jó = true;
                }

            }
        }

        //4. feladat lőérték számítása
        static int Loertek(string sor)
        {
            int aktpont = 20;
            int ertek = 0;
            for (int i = 0; i < sor.Length; i++)
            {
                if (aktpont > 0 && sor[i] == '-')
                {
                    aktpont = aktpont - 1;
                }
                else
                {
                    ertek = ertek + aktpont;
                }
            }
            return ertek;
        }
    }
}
